
// Vettori

public class Esempio1 {
	
	public static void main(String[] args) {
		
		// Un vettore di tre interi, inizializzato.
		int[] v;
		v = new int[3];
		v[0] = 1;
		v[1] = 2;
		v[2] = 3;
		
		int[] w;  // Un altro vettore
		
		// Qui copiamo il vettore v in w.
		// Tuttavia, questa operazione in Java non copia
		// le componenti del vettore ma copia il riferimento
		// al vettore stesso.
		w = v;
		
		// Ora v[i] e w[i] sono proprio la stessa componente.
		// Non hanno solo lo stesso valore, sono esattamente equivalenti.
		// Per esempio:
		w[1] = 1000;
		System.out.println("v[1] = " + v[1]);  // Stampa 1000
		// Sopra, modificando w[1], abbiamo modificato anche v[1]
		// perchè v e w si riferiscono allo stesso vettore.
		
		// Se vogliamo fare la copia delle componenti, dobbiamo
		// farlo copiando le componenti.
		w = new int[v.length];
		int i;
		for (i = 0 ; i < v.length ; i++) {
			w[i] = v[i];
		}
		
		// Modifichiamo di nuovo
		w[1] = 2000;
		
		// Stampiamo
		for (i = 0 ; i < v.length ; i++) {
			System.out.println("v[" + i + "] = " + v[i] + "    w[" + i + "] = " + w[i]);
		}
				
		// Esercizio 1.
		// Si definisca una funzione
		//    static int somma(int[] v)
		// che calcoli la somma del vettore.

		// Esercizio 2.
		// Si definisca una funzione
		//    static String concatena(String[] v)
		// che restituisca la stinga ottenuta concatenando tutte
		// le stringhe nel vettore.

		// Esercizio 3.
		// Si definisca una procedura
		//    static void limita(int[] v)
		// che modifichi il vettore in modo che ogni elemento negativo
		// diventi 0, e ogni elemento maggiore di 100 diventi 100.
		//
		// Si noti che la procedura può modificare il vettore del chiamante
		// perché il parametro v della procedura NON riceve un vettore nuovo
		// con la copia delle componenti, ma riceve (una copia de) il 
		// riferimento al vettore originario.
		
		// Esercizio 4.
		// Si definisca una funzione
		//    static double[] casuale(int n)
		// che restituisca un vettore casuale di double lungo n.
		
		// Esercizio 5.
		// Dato un vettore v, lo si permuti casualmente seguendo il seguente
		// algoritmo.
		// Sia n la lunghezza di v. Come prima cosa, generiamo un numero
		// intero casuale i nell'intervallo tra 0 e n escluso. Quindi scambiamo
		// i valori v[0] e v[i].
		// Dopo, generiamo un nuovo i casuale, tra 1 e n escluso, e scambiamo
		// i valori v[1] e v[i].
		// Dopo, generiamo un nuovo i casuale, tra 2 e n escluso, e scambiamo
		// i valori v[2] e v[i].
		// E così via fino alla fine del vettore.
		//
		// Per generare un intero casuale tra b e a+b escluso basta usare
		//    i = (int) (a*Math.random() + b);
	}

}
